import { defineComponent as y, openBlock as d, createElementBlock as h, createElementVNode as u, renderSlot as g, mergeModels as U, useModel as N, watch as O, useSlots as x, ref as P, onMounted as A, unref as i, Fragment as S, renderList as Y, createVNode as F, withCtx as $, createTextVNode as L, toDisplayString as E, createCommentVNode as M, toRefs as I, createBlock as R, resolveDynamicComponent as j } from "vue";
import * as t from "leaflet";
class w extends t.Control {
  // Optional 'cause it's initialized in `addTo`
  constructor(o, e) {
    if (e = e || {}, e.position) {
      const s = "Leaflet.SidePanel: You cannot set the `position` option. It is controlled by the `panelPosition` option.";
      e.panelPosition ? console.warn(s) : console.error(s);
    }
    e.panelPosition && !["left", "right"].includes(e.panelPosition) && (console.error(
      'Leaflet.SidePanel: The `panelPosition` option must be either "left" or "right".'
    ), e.panelPosition = "left"), e.tabsPosition && !["top", "bottom", "left", "right"].includes(e.tabsPosition) && (console.error(
      'Leaflet.SidePanel: The `tabsPosition` option must be either "top", "bottom", "left", or "right".'
    ), e.tabsPosition = "top"), super(e), this.options = {
      panelPosition: "left",
      hasTabs: !0,
      tabsPosition: "top",
      darkMode: !1,
      pushControls: !1,
      defaultTab: 1,
      size: "400px",
      onTabClick: () => {
      },
      onToggle: () => {
      },
      ...e
      // Merge with default options
    }, this._panel = t.DomUtil.get(o), this._panel.style.setProperty("--panel-width", this.options.size), t.setOptions(this, e);
  }
  addTo(o) {
    if (this._map = o, t.DomUtil.addClass(this._panel, "sidepanel-" + this.options.panelPosition), this.options.darkMode && t.DomUtil.addClass(this._panel, "sidepanel-dark"), t.DomEvent.disableScrollPropagation(this._panel), t.DomEvent.disableClickPropagation(this._panel), this.options.pushControls) {
      const e = this._map, s = (e instanceof t.Map ? e.getContainer() : e).querySelector(
        ".leaflet-control-container"
      );
      t.DomUtil.addClass(
        s,
        "leaflet-animate-control-container"
      ), s.style.setProperty(
        `--panel-width-${this.options.panelPosition}`,
        this.options.size
      );
    }
    return this.options.hasTabs ? this._initTabs(this.options.tabsPosition) : this._initContent(), this;
  }
  // Define the private methods as part of the class
  _initContent() {
    this._toggleButton();
  }
  _initTabs(o) {
    t.DomUtil.addClass(this._panel, "tabs-" + o);
    const e = this._panel.querySelectorAll(
      "a.sidebar-tab-link"
    ), s = this._panel.querySelectorAll(
      ".sidepanel-tab-content"
    );
    e.forEach((a, n) => {
      let l = !1, b;
      typeof this.options.defaultTab == "number" && this.options.defaultTab - 1 === n && (l = !0, b = s[n]), typeof this.options.defaultTab == "string" && this.options.defaultTab === a.dataset.tabLink && (l = !0, b = this._panel.querySelector(
        `.sidepanel-tab-content[data-tab-content="${this.options.defaultTab}"]`
      )), l && (t.DomUtil.addClass(a, "active"), t.DomUtil.addClass(b, "active")), t.DomEvent.on(
        a,
        "click",
        (C) => {
          t.DomEvent.preventDefault(C), e.forEach((p) => t.DomUtil.removeClass(p, "active")), t.DomUtil.addClass(a, "active"), s.forEach((p) => {
            a.dataset.tabLink === p.dataset.tabContent ? t.DomUtil.addClass(p, "active") : t.DomUtil.removeClass(p, "active");
          }), this.options.onTabClick(a);
        },
        a
      );
    }), this._toggleButton();
  }
  toggle(o) {
    let e = !0;
    const s = t.DomUtil.hasClass(this._panel, "opened"), a = t.DomUtil.hasClass(this._panel, "closed");
    if (!s && !a ? t.DomUtil.addClass(this._panel, "opened") : !s && a ? (t.DomUtil.addClass(this._panel, "opened"), t.DomUtil.removeClass(this._panel, "closed")) : s && !a && (e = !1, t.DomUtil.removeClass(this._panel, "opened"), t.DomUtil.addClass(this._panel, "closed")), this.options.pushControls) {
      const n = this._map;
      if (n) {
        const l = (n instanceof t.Map ? n.getContainer() : n).querySelector(
          ".leaflet-control-container"
        );
        e ? (t.DomUtil.removeClass(
          l,
          this.options.panelPosition + "-closed"
        ), t.DomUtil.addClass(
          l,
          this.options.panelPosition + "-opened"
        )) : (t.DomUtil.removeClass(
          l,
          this.options.panelPosition + "-opened"
        ), t.DomUtil.addClass(
          l,
          this.options.panelPosition + "-closed"
        ));
      } else
        console.error(
          "Leaflet.SidePanel: You must add the SidePanel to the map before setting the `pushControls` option."
        );
    }
    this.options.onToggle(e);
  }
  isOpened() {
    return t.DomUtil.hasClass(this._panel, "opened");
  }
  open() {
    this.isOpened() || this.toggle();
  }
  close() {
    this.isOpened() && this.toggle();
  }
  _toggleButton() {
    const o = this._panel.querySelector(
      ".sidepanel-toggle-container"
    ), e = o.querySelector(
      ".sidepanel-toggle-button"
    );
    t.DomEvent.on(
      e,
      "click",
      (s) => {
        this.toggle(s);
      },
      o
    );
  }
}
t.Control.SidePanel = w;
t.control.sidepanel = function(r, o) {
  return new w(r, o);
};
const G = { class: "sidepanel-tab" }, H = ["data-tab-link"], J = /* @__PURE__ */ y({
  __name: "LSidepanelTabNav",
  props: {
    link: {}
  },
  setup(r) {
    return (o, e) => (d(), h("li", G, [
      u("a", {
        href: "#",
        class: "sidebar-tab-link",
        role: "tab",
        "data-tab-link": `tab-${o.link}`
      }, [
        g(o.$slots, "default")
      ], 8, H)
    ]));
  }
}), K = ["id"], Q = { class: "sidepanel-inner-wrapper" }, W = {
  key: 0,
  class: "sidepanel-tabs-wrapper",
  "aria-label": "sidepanel tab navigation"
}, X = { class: "sidepanel-tabs" }, Z = { class: "sidepanel-content-wrapper" }, ee = { class: "sidepanel-content" }, se = /* @__PURE__ */ y({
  __name: "LSidepanel",
  props: /* @__PURE__ */ U({
    id: {},
    headings: { default: void 0 },
    position: { default: "left" },
    tabsPosition: { default: "top" },
    darkMode: { type: Boolean, default: !1 },
    defaultTab: { default: 1 },
    pushControls: { type: Boolean, default: !1 },
    size: { default: "400px" }
  }, {
    modelValue: { type: Boolean, default: !1, required: !1 },
    modelModifiers: {}
  }),
  emits: /* @__PURE__ */ U(["tabClick"], ["update:modelValue"]),
  setup(r, { emit: o }) {
    const e = N(r, "modelValue");
    O(e, (c) => {
      v.value && (c ? D() : T());
    });
    const s = r, {
      id: a,
      headings: n,
      position: l,
      tabsPosition: b,
      darkMode: C,
      defaultTab: p,
      pushControls: B,
      size: q
    } = s, V = o, z = x(), k = P(null), v = P(null), f = P();
    A(() => {
      var c;
      if (!v.value) return console.error("Panel not found");
      if (k.value = v.value.parentElement, !k.value) return console.error("Map not found");
      f.value = t.control.sidepanel(a, {
        panelPosition: l,
        hasTabs: n && n.length > 0,
        tabsPosition: b,
        darkMode: C,
        defaultTab: p || ((c = n == null ? void 0 : n[0]) == null ? void 0 : c.key),
        pushControls: B,
        size: q,
        onTabClick: (m) => V("tabClick", m),
        onToggle: (m) => e.value = m
      }), f.value.addTo(k.value), e.value ? D() : T();
    });
    const D = () => {
      if (!f.value) return console.error("Panel not found");
      f.value.open(), e.value = !0;
    }, T = () => {
      if (!f.value) return console.error("Panel not found");
      f.value.close(), e.value = !1;
    };
    return (c, m) => (d(), h("div", {
      id: i(a),
      ref_key: "panel",
      ref: v,
      class: "sidepanel",
      "aria-label": "side panel",
      "aria-hidden": "false"
    }, [
      u("div", Q, [
        i(n) && i(n).length > 0 ? (d(), h("nav", W, [
          u("ul", X, [
            (d(!0), h(S, null, Y(i(n), (_) => (d(), h("li", {
              key: _.key
            }, [
              F(J, {
                link: _.key
              }, {
                default: $(() => [
                  i(z)[`heading.${_.key}`] ? g(c.$slots, `heading.${_.key}`, { key: 0 }) : (d(), h(S, { key: 1 }, [
                    L(E(_.value), 1)
                  ], 64))
                ]),
                _: 2
              }, 1032, ["link"])
            ]))), 128))
          ])
        ])) : M("", !0),
        u("div", Z, [
          u("div", ee, [
            g(c.$slots, "default")
          ])
        ])
      ]),
      m[0] || (m[0] = u("div", { class: "sidepanel-toggle-container" }, [
        u("button", {
          class: "sidepanel-toggle-button",
          type: "button",
          "aria-label": "toggle side panel"
        })
      ], -1))
    ], 8, K));
  }
}), te = ["data-tab-content"], ne = /* @__PURE__ */ y({
  __name: "LSidepanelTab",
  props: {
    link: {},
    level: { default: "h3" },
    heading: { default: void 0 }
  },
  setup(r) {
    const o = r, { link: e, level: s, heading: a } = I(o);
    return (n, l) => (d(), h("div", {
      class: "sidepanel-tab-content",
      "data-tab-content": `tab-${i(e)}`
    }, [
      i(a) ? (d(), R(j(i(s)), { key: 0 }, {
        default: $(() => [
          L(E(i(a)), 1)
        ]),
        _: 1
      })) : M("", !0),
      g(n.$slots, "default")
    ], 8, te));
  }
});
export {
  se as LSidepanel,
  ne as LSidepanelTab
};
